
#ifndef INCLUDE_WATCHER_ITA_SOUND_SAMPLER_SLOT_BUFFER
#define INCLUDE_WATCHER_ITA_SOUND_SAMPLER_SLOT_BUFFER

#include <string>
#include <vector>

#include "ITASoundSamplerSlot.h"

class ITASoundSamplerSlotbuffer
{
public:
	ITASoundSamplerSlotbuffer();
	~ITASoundSamplerSlotbuffer();

	// Gre des Puffers ndern
	void Resize(int iNumSlots);

	// Slot zurckgeben (beinhaltet implizites Resizing)
	ITASoundSamplerSlot* GetSlot(int iBlockIndex);

	// Alle Playbacks eines Samples lschen und freigeben
	void DeletePlaybacksOfSample(int iSampleID);

	// Alle Playbacks einer Spur lschen und freigeben
	void DeletePlaybacksOfTrack(int iTrackID);

	// Alle Playbacks lschen und freigeben
	void DeleteAllPlaybacks();

	// Leseposition weitersetzen
	void IncrementPlaybackBlock();

private:
	int m_iSize;
	int m_iPlaybackCursor;
	int m_iPlaybackBlock;
	std::vector<ITASoundSamplerSlot> m_vSlots;
};

#endif // INCLUDE_WATCHER_ITA_SOUND_SAMPLER_SLOT_BUFFER
